//****************************************************************//
//                                                                //
// class Vocabulary                                               //
//        was programmed by Etsuko with Visual J++ 1.1 (JDK 1.02) //
//                                                                //
//****************************************************************//

import java.applet.*;
import java.awt.*;

public class Vocabulary extends Applet{
    
    String quizNumber_p;//question numbers from parameter
    String question_p[];//questions from parameter
    String ansJ_p[];    //answers(Japanese) from parameter
    String ansR_p[];    //answers(Romaji) from parameter
    String fontA_p;     //font size for answer from parameter
    String fontQ_p;     //font size for question from parameter
    String message_p;   //answerPanel message from parameter

    int quizNumber;             //quiz number
    int fontSizeA, fontSizeQ;   //font size

    Panel quizPanel  = new Panel();     //panel for questions
    Panel soundPanel = new Panel();     //panel for sound on/ff
    Panel sellectPanel = new Panel();   //language select panel
    Panel sellectAllPanel = new Panel();//panel for select language
    Panel answerPanel = new Panel();    //panel for answers

    Button q[];
    Label answerMessage;
    CheckboxGroup cbg;  //checkbox for selecting answer language
    Checkbox kanjiCB;
    Checkbox romajiCB;
    Checkbox soundCB;
    AudioClip sound1;   //sound

    public void init(){ 
    
        sound1 = getAudioClip(getDocumentBase(), "./1.au");
        setLayout(new BorderLayout());
        questionPanelSetting();
        answerPanelSetting();
        lowerPanelSetting();
        
    }


//---------------------- answer panel setting---------------------------//

    public void answerPanelSetting(){
        
        fontA_p = getParameter("Afont");    //get font size from parameter
        if(fontA_p == null)fontA_p = "15";
        fontSizeA = Integer.parseInt(fontA_p);
        ansJ_p = new String[quizNumber];    
        ansR_p = new String[quizNumber];    

        for(int n =0; n<quizNumber; n++){   //get answers from parameter
            ansJ_p[n] = getParameter("answer_j"+(n+1));
            if(ansJ_p[n] == null){ansJ_p[n] = "Error";}
            ansR_p[n] = getParameter("answer_r"+(n+1));
            if(ansR_p[n] == null){ansR_p[n] = "Error";}
        }

        message_p = getParameter("message");
        if(message_p == null){message_p = "Please click a button below.";}

        Font ansF = new Font("Dialog", Font.PLAIN, fontSizeA);
        answerMessage = new Label(message_p);
        answerMessage.setFont(ansF);
        answerMessage.setBackground(Color.black);
        answerMessage.setForeground(Color.white);

        answerPanel.add(answerMessage);
        answerPanel.setBackground(Color.black);
        sellectAllPanel.setBackground(Color.black);
        add("South", sellectAllPanel);
        add("North", answerPanel);
        
    }


//---------------- question panel setting ----------------------------//

    public void questionPanelSetting(){
        
        add("Center", quizPanel);
        quizPanel.setBackground(Color.darkGray);       
        fontQ_p = getParameter("Qfont");    //get font size from parameter
        if(fontQ_p == null)fontQ_p = "15";
        fontSizeQ = Integer.parseInt(fontQ_p);
        Font quizF = new Font("Dialog", Font.PLAIN, fontSizeQ);
        quizPanel.setFont(quizF);

        quizNumber_p = getParameter("maxQuizNum");  //get question number from parameter
        if(quizNumber_p == null)quizNumber_p = "1";
        quizNumber = Integer.parseInt(quizNumber_p);

        quizPanel.setLayout(new GridLayout(quizNumber,1));
        q = new Button[quizNumber];
        question_p = new String[quizNumber];
    
        for(int n =0; n<quizNumber; n++){       //get questions from parameter
            question_p[n] = getParameter("question_"+(n+1));
            if(question_p[n] == null){question_p[n] = "Error";}
            q[n] = new Button(""+question_p[n]);
            quizPanel.add(q[n]);
        }
    }


//----------- answer language select and sound panel setting -----------//

    public void lowerPanelSetting(){
        
        soundPanel.setBackground(Color.black);       
        sellectPanel.setBackground(Color.black);       
        sellectPanel.setLayout(new GridLayout(1,2));
        cbg = new CheckboxGroup();
        kanjiCB = new Checkbox("/", cbg, true);
        romajiCB = new Checkbox("Romaji", cbg, false);
        kanjiCB.setBackground(Color.black);
        romajiCB.setBackground(Color.black);
        kanjiCB.setForeground(Color.white);
        romajiCB.setForeground(Color.white);
        sellectPanel.setFont(new Font("Dialog", Font.PLAIN, 17));
        sellectPanel.add(kanjiCB);
        sellectPanel.add(romajiCB);

        soundCB = new Checkbox("sound on/off");
        soundCB.setState(true);
        soundCB.setBackground(Color.black);
        soundCB.setForeground(Color.white);
        soundPanel.setFont(new Font("Dialog", Font.PLAIN, 17));
        soundPanel.add(soundCB);

        sellectAllPanel.setLayout(new GridLayout(1,2));
        sellectAllPanel.add(sellectPanel);
        sellectAllPanel.add(soundPanel);
        
    }


//------------- Action when a button was pushed ------------------------//

    public boolean action(Event e, Object o){
        
        if(e.target instanceof Button){ //if sound box is checked play sound
            if(soundCB.getState() == true){
                sound1.play();
            }
    
    //show answers in Nihongo or Romaji according to the selected language
            if(cbg.getCurrent().equals(kanjiCB)){
                for(int k=0; k<quizNumber; k++){
                    if(q[k].getLabel().equals(o)){
                        answerMessage.setText(ansJ_p[k]);
                    }
                }
            }
        
            if(cbg.getCurrent().equals(romajiCB)){
                for(int k=0; k<quizNumber; k++){
                    if(q[k].getLabel().equals(o)){
                        answerMessage.setText(ansR_p[k]);
                    }
                }
            }
        }
        return true;
    }
    
}
///-----